## onnxruntime 1.19.2+dfsg

=== cmake/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

# Minimum CMake required
cmake_minimum_required(VERSION 3.26)

cmake_policy(SET CMP0069 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)

cmake_policy(SET CMP0092 NEW)
cmake_policy(SET CMP0091 NEW)
cmake_policy(SET CMP0117 NEW)
# Don't let cmake set a default value for CMAKE_CUDA_ARCHITECTURES
cmake_policy(SET CMP0104 OLD)

# Enable Hot Reload for MSVC compilers if supported.
cmake_policy(SET CMP0141 NEW)

# Project
project(onnxruntime C CXX ASM)

# Disable fast-math for Intel oneAPI compiler
if("${CMAKE_CXX_COMPILER_ID}" MATCHES "IntelLLVM")
  if("${CMAKE_CXX_COMPILER_ID}" MATCHES "MSVC-like")
    # Using icx-cl compiler driver with MSVC-like arguments
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fp:precise")
  else()
    # Using icpx compiler driver
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-fast-math")
  endif()
endif()

# Needed for Java
set(CMAKE_C_STANDARD 99)

include(CheckCXXCompilerFlag)
include(CheckLanguage)
include(CMakeDependentOption)
include(FetchContent)
include(CheckFunctionExists)

# TODO: update this once all system adapt c++20
if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
set(CMAKE_CXX_STANDARD 20)
else()
set(CMAKE_CXX_STANDARD 17)
endif()

if (MSVC)
  #  Make sure Visual Studio sets __cplusplus macro correctly: https://learn.microsoft.com/en-us/cpp/build/reference/zc-cplusplus
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
# NOTE: POSITION INDEPENDENT CODE hurts performance, and it only make sense on POSIX systems
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Enable CTest
enable_testing()
include(Dart)

if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "Build type not set - using RelWithDebInfo")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose build type: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_LESS 9)
  message(FATAL_ERROR  "GCC version must be greater than or equal to 9")
endif()

# Options
option(onnxruntime_RUN_ONNX_TESTS "Enable ONNX Compatibility Testing" OFF)
option(onnxruntime_GENERATE_TEST_REPORTS "Enable test report generation" OFF)
option(onnxruntime_ENABLE_STATIC_ANALYSIS "Enable static analysis" OFF)
option(onnxruntime_USE_CUSTOM_STATIC_ANALYSIS_RULES "Use a custom SDL Rule. It is mainly for our CI build" OFF)
option(onnxruntime_REDIRECT_STATIC_ANALYSIS_OUTPUTS_TO_FILE "Use a custom SDL Rule. It is mainly for our CI build" OFF)
option(onnxruntime_ENABLE_PYTHON "Enable python buildings" OFF)
# Enable it may cause LNK1169 error
option(onnxruntime_ENABLE_MEMLEAK_CHECKER "Experimental: Enable memory leak checker in Windows debug build" OFF)
option(onnxruntime_USE_CUDA "Build with CUDA support" OFF)
# Enable ONNX Runtime CUDA EP's internal unit tests that directly access the EP's internal functions instead of through
# OpKernels. When the option is ON, we will have two copies of GTest library in the same process. It is not a typical
# use. If you hit any problem with that, please do not report it to GTest. Turn OFF the following build option instead.
cmake_dependent_option(onnxruntime_ENABLE_CUDA_EP_INTERNAL_TESTS "Build with CUDA unit tests" OFF "onnxruntime_USE_CUDA;onnxruntime_BUILD_UNIT_TESTS" OFF)

option(onnxruntime_USE_CUDA_NHWC_OPS "Build CUDA with NHWC op support" OFF)
option(onnxruntime_CUDA_MINIMAL "Build CUDA without any operations apart from memcpy ops. Usefuel for a very minial TRT build" OFF)
option(onnxruntime_ENABLE_CUDA_LINE_NUMBER_INFO "When building with CUDA support, generate device code line number information." OFF)
option(onnxruntime_USE_OPENVINO "Build with OpenVINO support" OFF)
option(onnxruntime_USE_COREML "Build with CoreML support" OFF)
option(onnxruntime_USE_NNAPI_BUILTIN "Build with builtin NNAPI lib for Android NNAPI support" OFF)
option(onnxruntime_USE_QNN "Build with QNN support" OFF)
option(onnxruntime_USE_SNPE "Build with SNPE support" OFF)
option(onnxruntime_USE_RKNPU "Build with RKNPU support" OFF)
option(onnxruntime_USE_DNNL "Build with DNNL support" OFF)
option(onnxruntime_USE_NEURAL_SPEED "Build with Neural Speed support" OFF)
option(onnxruntime_USE_JSEP "Build with JavaScript implemented kernels support" OFF)
option(onnxruntime_BUILD_UNIT_TESTS "Build ONNXRuntime unit tests" ON)
option(onnxruntime_BUILD_CSHARP "Build C# library" OFF)
option(onnxruntime_BUILD_OBJC "Build Objective-C library" OFF)
option(onnxruntime_USE_PREINSTALLED_EIGEN "Use pre-installed EIGEN. Need to provide eigen_SOURCE_PATH if turn this on." OFF)
option(onnxruntime_BUILD_BENCHMARKS "Build ONNXRuntime micro-benchmarks" OFF)
option(onnxruntime_USE_LLVM "Build TVM with LLVM" OFF)
option(onnxruntime_USE_VSINPU "Build with VSINPU support" OFF)

cmake_dependent_option(onnxruntime_USE_FLASH_ATTENTION "Build flash attention kernel for scaled dot product attention" ON "onnxruntime_USE_CUDA" OFF)
option(onnxruntime_USE_MEMORY_EFFICIENT_ATTENTION "Build memory efficient attention kernel for scaled dot product attention" ON)

option(onnxruntime_BUILD_FOR_NATIVE_MACHINE "Enable this option for turning on optimization specific to this machine" OFF)
option(onnxruntime_USE_AVX "Use AVX instructions" OFF)
option(onnxruntime_USE_AVX2 "Use AVX2 instructions" OFF)
option(onnxruntime_USE_AVX512 "Use AVX512 instructions" OFF)

option(onnxruntime_BUILD_SHARED_LIB "Build a shared library" OFF)
option(onnxruntime_BUILD_APPLE_FRAMEWORK "Build a macOS/iOS framework" OFF)
option(onnxruntime_ENABLE_MICROSOFT_INTERNAL "Use this option to enable/disable microsoft internal only code" OFF)

option(onnxruntime_USE_VITISAI "Build with Vitis-AI" OFF)
option(onnxruntime_USE_TENSORRT "Build with TensorRT support" OFF)
option(onnxruntime_USE_TENSORRT_BUILTIN_PARSER "Use TensorRT builtin parser" OFF)
option(onnxruntime_ENABLE_LTO "Enable link time optimization" OFF)
option(onnxruntime_CROSS_COMPILING "Cross compiling onnx runtime" OFF)
option(onnxruntime_GCOV_COVERAGE "Compile with options necessary to run code coverage" OFF)
option(onnxruntime_DONT_VECTORIZE "Do not vectorize operations in Eigen" OFF)

option(onnxruntime_USE_FULL_PROTOBUF "Link to libprotobuf instead of libprotobuf-lite when this option is ON" OFF)
option(onnxruntime_DEBUG_NODE_INPUTS_OUTPUTS "Dump debug information about node inputs and outputs when executing the model." OFF)
cmake_dependent_option(onnxruntime_DEBUG_NODE_INPUTS_OUTPUTS_ENABLE_DUMP_TO_SQLDB "Build dump debug information about node inputs and outputs with support for sql database." OFF "onnxruntime_DEBUG_NODE_INPUTS_OUTPUTS" OFF)
option(onnxruntime_USE_DML "Build with DirectML support" OFF)
option(onnxruntime_USE_MIGRAPHX "Build with AMDMIGraphX support" OFF)
option(onnxruntime_USE_WINML "Build with WinML support" OFF)
option(onnxruntime_USE_ACL "Build with ACL support" OFF)
option(onnxruntime_USE_ACL_1902 "Build with ACL version 1902 support" OFF)
option(onnxruntime_USE_ACL_1905 "Build with ACL version 1905 support" OFF)
option(onnxruntime_USE_ACL_1908 "Build with ACL version 1908 support" OFF)
option(onnxruntime_USE_ACL_2002 "Build with ACL version 2002 support" OFF)
option(onnxruntime_USE_ACL_2308 "Build with ACL version 2308 support" OFF)
option(onnxruntime_USE_ARMNN "Build with ArmNN support" OFF)
option(onnxruntime_ARMNN_RELU_USE_CPU "Use the CPU implementation for the Relu operator for the ArmNN EP" ON)
option(onnxruntime_ARMNN_BN_USE_CPU "Use the CPU implementation for the Batch Normalization operator for the ArmNN EP" ON)
option(onnxruntime_ENABLE_INSTRUMENT "Enable Instrument with Event Tracing for Windows (ETW)" OFF)
option(onnxruntime_USE_TELEMETRY "Build with Telemetry" OFF)
cmake_dependent_option(onnxruntime_USE_MIMALLOC "Override new/delete and arena allocator with mimalloc" OFF "WIN32;NOT onnxruntime_USE_CUDA;NOT onnxruntime_USE_OPENVINO" OFF)
option(onnxruntime_USE_CANN "Build with CANN support" OFF)
option(onnxruntime_USE_ROCM "Build with AMD GPU support" OFF)
option(onnxruntime_USE_TVM "Build with TVM support" OFF)
option(onnxruntime_TVM_CUDA_RUNTIME "Build TVM with CUDA support" OFF)
option(onnxruntime_TVM_USE_LLVM "Build TVM with LLVM. Set customized path to llvm-config.exe here if need" OFF)
option(onnxruntime_TVM_USE_HASH "Build ipp-crypto library for support hash algorithm. It is defined for TVM only")
option(onnxruntime_USE_XNNPACK "Build with XNNPACK support. Provides an alternative math library on ARM, WebAssembly and x86." OFF)
option(onnxruntime_USE_WEBNN "Build with WebNN support. Enable hardware acceleration in web browsers." OFF)

# Options related to reducing the binary size produced by the build
# XNNPACK EP requires the internal NHWC contrib ops to be available, so this option must be OFF when onnxruntime_USE_XNNPACK is ON
cmake_dependent_option(onnxruntime_DISABLE_CONTRIB_OPS "Disable contrib ops" OFF "NOT onnxruntime_USE_XNNPACK" OFF)
option(onnxruntime_DISABLE_ML_OPS "Disable traditional ML ops" OFF)
option(onnxruntime_DISABLE_SPARSE_TENSORS "Disable sparse tensors data types" OFF)
option(onnxruntime_DISABLE_OPTIONAL_TYPE "Disable optional type" OFF)
option(onnxruntime_DISABLE_FLOAT8_TYPES "Disable float 8 types" OFF)
option(onnxruntime_MINIMAL_BUILD "Exclude as much as possible from the build. Support ORT format models. No support for ONNX format models." OFF)
cmake_dependent_option(onnxruntime_DISABLE_RTTI "Disable RTTI" ON "NOT onnxruntime_ENABLE_PYTHON;NOT onnxruntime_USE_CUDA" OFF)
# For now onnxruntime_DISABLE_EXCEPTIONS will only work with onnxruntime_MINIMAL_BUILD, more changes (ONNX, non-CPU EP, ...) are required to run this standalone
cmake_dependent_option(onnxruntime_DISABLE_EXCEPTIONS "Disable exception handling. Requires onnxruntime_MINIMAL_BUILD currently." ON "onnxruntime_MINIMAL_BUILD;NOT onnxruntime_ENABLE_PYTHON" OFF)
# Even when onnxruntime_DISABLE_ABSEIL is ON, ONNX Runtime still needs to link to abseil.
option(onnxruntime_DISABLE_ABSEIL "Do not use Abseil data structures in ONNX Runtime source code. Redefine Inlined containers to STD containers." OFF)

option(onnxruntime_EXTENDED_MINIMAL_BUILD "onnxruntime_MINIMAL_BUILD with support for execution providers that compile kernels." OFF)
option(onnxruntime_MINIMAL_BUILD_CUSTOM_OPS "Add custom operator kernels support to a minimal build." OFF)
option(onnxruntime_REDUCED_OPS_BUILD "Reduced set of kernels are registered in build via modification of the kernel registration source files." OFF)
option(onnxruntime_DISABLE_EXTERNAL_INITIALIZERS "Don't allow models to load external data" OFF)

#A special option just for debugging and sanitize check. Please do not enable in option in retail builds.
#The option has no effect on Windows.
option(onnxruntime_USE_VALGRIND "Build with valgrind hacks" OFF)

# A special build option only used for gathering code coverage info
option(onnxruntime_RUN_MODELTEST_IN_DEBUG_MODE "Run model tests even in debug mode" OFF)

# options for security fuzzing
# build configuration for fuzz testing is in onnxruntime_fuzz_test.cmake
option(onnxruntime_FUZZ_TEST "Enable Fuzz testing" OFF)

# training options
option(onnxruntime_ENABLE_NVTX_PROFILE "Enable NVTX profile." OFF)
option(onnxruntime_ENABLE_MEMORY_PROFILE "Enable memory profile." OFF)
option(onnxruntime_ENABLE_TRAINING "Enable full training functionality. Includes ORTModule and ORT Training APIs" OFF)
option(onnxruntime_ENABLE_TRAINING_APIS "Enable ort training apis." OFF)
option(onnxruntime_ENABLE_TRAINING_OPS "Include training operators but no training session support." OFF)
option(onnxruntime_ENABLE_TRAINING_E2E_TESTS "Enable training end-to-end tests." OFF)
option(onnxruntime_ENABLE_CPU_FP16_OPS "Build with advanced instruction sets" ON)
option(onnxruntime_USE_NCCL "Build with NCCL support" OFF)
option(onnxruntime_USE_MPI "Build with MPI support" OFF)

# WebAssembly options
option(onnxruntime_BUILD_WEBASSEMBLY_STATIC_LIB "Enable this option to create WebAssembly static library" OFF)

=== docs/python/requirements.txt ===
autopep8
matplotlib
scikit-learn
skl2onnx
sphinx==5.3.0
sphinx-gallery
sphinxcontrib.imagesvg
sphinxcontrib.googleanalytics
sphinx_rtd_theme
furo
pyquickhelper
pandas
pydot
coloredlogs
flatbuffers
numpy
packaging
protobuf
sympy
onnx
sphinx_exec_code
sphinx_tabs
furo
-f https://download.pytorch.org/whl/torch/
torch

=== js/node/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project (onnxruntime-node)

set(CMAKE_CXX_STANDARD 14)

add_compile_definitions(NAPI_VERSION=${napi_build_version})
add_compile_definitions(ORT_API_MANUAL_INIT)

# dist variables
execute_process(COMMAND node -e "console.log(process.platform)"
                OUTPUT_VARIABLE node_platform OUTPUT_STRIP_TRAILING_WHITESPACE)
file(READ ${CMAKE_SOURCE_DIR}/../../VERSION_NUMBER ort_version)
string(STRIP "${ort_version}" ort_version)
set(dist_folder "${CMAKE_SOURCE_DIR}/bin/napi-v3/${node_platform}/${NODE_ARCH}/")

# onnxruntime.dll dir
if(NOT ONNXRUNTIME_BUILD_DIR)
  if (WIN32)
    set(ONNXRUNTIME_BUILD_DIR ${CMAKE_SOURCE_DIR}/../../build/Windows/${CMAKE_BUILD_TYPE})
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(ONNXRUNTIME_BUILD_DIR ${CMAKE_SOURCE_DIR}/../../build/MacOS/${CMAKE_BUILD_TYPE})
  else()
    set(ONNXRUNTIME_BUILD_DIR ${CMAKE_SOURCE_DIR}/../../build/Linux/${CMAKE_BUILD_TYPE})
  endif()
endif()

# include dirs
include_directories(${CMAKE_JS_INC})
include_directories(${CMAKE_SOURCE_DIR}/../../include/onnxruntime/core/session)
include_directories(${CMAKE_SOURCE_DIR}/../../include/onnxruntime)
include_directories(${CMAKE_SOURCE_DIR}/../../onnxruntime)
include_directories(${CMAKE_SOURCE_DIR}/node_modules/node-addon-api)

# optional providers
option(USE_DML "Build with DirectML support" OFF)
option(USE_CUDA "Build with CUDA support" OFF)
option(USE_TENSORRT "Build with TensorRT support" OFF)
option(USE_COREML "Build with CoreML support" OFF)
option(USE_QNN "Build with QNN support" OFF)

if(USE_DML)
  add_compile_definitions(USE_DML=1)
endif()
if(USE_CUDA)
  add_compile_definitions(USE_CUDA=1)
endif()
if(USE_TENSORRT)
  add_compile_definitions(USE_TENSORRT=1)
endif()
if(USE_COREML)
  add_compile_definitions(USE_COREML=1)
endif()
if(USE_QNN)
  add_compile_definitions(USE_QNN=1)
endif()

# source files
file(GLOB ORT_NODEJS_BINDING_SOURCE_FILES ${CMAKE_SOURCE_DIR}/src/*.cc)

add_library(onnxruntime_binding SHARED ${ORT_NODEJS_BINDING_SOURCE_FILES} ${CMAKE_JS_SRC})
file(MAKE_DIRECTORY ${dist_folder})

set_target_properties(onnxruntime_binding PROPERTIES
  PREFIX "" SUFFIX ".node"
  RUNTIME_OUTPUT_DIRECTORY ${dist_folder}
  RUNTIME_OUTPUT_DIRECTORY_DEBUG ${dist_folder}
  RUNTIME_OUTPUT_DIRECTORY_RELEASE ${dist_folder}
  RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY_DEBUG ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY_RELEASE ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO ${dist_folder}
  BUILD_WITH_INSTALL_RPATH TRUE
  INSTALL_RPATH_USE_LINK_PATH FALSE)
target_link_libraries(onnxruntime_binding PRIVATE ${CMAKE_JS_LIB})

if(MSVC AND CMAKE_JS_NODELIB_DEF AND CMAKE_JS_NODELIB_TARGET)
  # Generate node.lib
  execute_process(COMMAND ${CMAKE_AR} /def:${CMAKE_JS_NODELIB_DEF} /out:${CMAKE_JS_NODELIB_TARGET} ${CMAKE_STATIC_LINKER_FLAGS})
endif()

if (WIN32)
  if (${ONNXRUNTIME_GENERATOR} MATCHES "Ninja")
    set(ONNXRUNTIME_WIN_BIN_DIR ${ONNXRUNTIME_BUILD_DIR})
  else()
    set(ONNXRUNTIME_WIN_BIN_DIR ${ONNXRUNTIME_BUILD_DIR}/${CMAKE_BUILD_TYPE})
  endif()
  message(STATUS "onnxruntime dist dir: ${ONNXRUNTIME_WIN_BIN_DIR}")
endif()
# add libraries
if (WIN32)
  target_link_directories(onnxruntime_binding PRIVATE ${ONNXRUNTIME_WIN_BIN_DIR})
else()
  target_link_directories(onnxruntime_binding PRIVATE ${ONNXRUNTIME_BUILD_DIR})
endif()

if (WIN32)
  target_link_libraries(onnxruntime_binding PRIVATE onnxruntime)
elseif (APPLE)
  target_link_libraries(onnxruntime_binding PRIVATE libonnxruntime.${ort_version}.dylib)
  set_target_properties(onnxruntime_binding PROPERTIES INSTALL_RPATH "@loader_path")
else()
  target_link_libraries(onnxruntime_binding PRIVATE onnxruntime)
  set_target_properties(onnxruntime_binding PROPERTIES INSTALL_RPATH "$ORIGIN/")
endif()


if (WIN32)
  file(COPY ${ONNXRUNTIME_WIN_BIN_DIR}/onnxruntime.dll
      DESTINATION ${dist_folder})
  if (USE_DML)
    file(COPY ${ONNXRUNTIME_WIN_BIN_DIR}/DirectML.dll
      DESTINATION ${dist_folder})
  endif ()
elseif (APPLE)
  file(COPY ${ONNXRUNTIME_BUILD_DIR}/libonnxruntime.dylib
      DESTINATION ${dist_folder} FOLLOW_SYMLINK_CHAIN)
elseif (UNIX)
  file(COPY ${ONNXRUNTIME_BUILD_DIR}/libonnxruntime.so
      DESTINATION ${dist_folder} FOLLOW_SYMLINK_CHAIN)
else()
  message(FATAL_ERROR "Platform not supported.")
endif()

=== onnxruntime/test/python/requirements.txt ===
onnx==1.16.1
pytest

=== tools/ci_build/requirements/pybind/requirements.txt ===
setuptools
wheel
pytest
numpy>=1.19.0
sympy>=1.10
packaging
cerberus
psutil

=== tools/ci_build/requirements/transformers-test/requirements.txt ===
# packages used by transformers python unittest (only enabled in Linux CPU CI Pipeline)
packaging
protobuf==3.20.2
numpy==1.24.0 ; python_version < '3.12'
numpy==1.26.0 ; python_version >= '3.12'
torch
coloredlogs==15.0
transformers==4.38.0
parameterized>=0.8.1
psutil
einops

=== tools/ci_build/github/windows/eager/requirements.txt ===
setuptools
wheel
numpy==1.21.6 ; python_version < '3.9'
numpy==2.0.0 ; python_version >= '3.9'
typing_extensions
torch==1.13.1
parameterized

=== onnxruntime/python/tools/transformers/models/llama/requirements.txt ===
optimum>=1.14.1
transformers>=4.33.2,<= 4.37.2
torch>=2.2.0
onnx==1.16.1
datasets>=2.8.0
protobuf==3.20.2
psutil

=== onnxruntime/python/tools/transformers/models/phi2/requirements.txt ===
onnx==1.16.1
transformers>=4.36.2
onnxscript>=0.1.0.dev20240126

=== onnxruntime/python/tools/transformers/models/stable_diffusion/requirements.txt ===
diffusers==0.28.0
transformers==4.41.2
numpy>=1.24.1
accelerate
onnx==1.16.0
coloredlogs
packaging
# Use newer version of protobuf might cause crash
protobuf==3.20.3
psutil
sympy
controlnet_aux==0.0.7
# The following are for SDXL
optimum==1.20.0
safetensors
invisible_watermark
# newer version of opencv-python migth encounter module 'cv2.dnn' has no attribute 'DictValue' error
opencv-python==4.8.0.74

=== onnxruntime/python/tools/transformers/models/whisper/requirements.txt ===
torch>=1.13.0
transformers>=4.24.0,<= 4.42.4
openai-whisper>=20231117
ffmpeg-python
datasets
soundfile
librosa
optimum<=1.21.2
onnxruntime-extensions>=0.9.0
onnx==1.16.1
protobuf==3.20.2
numpy==1.23.3
psutil
py3nvml

=== tools/ci_build/github/linux/docker/scripts/requirements.txt ===
cerberus
numpy==1.24.4 ; python_version < '3.9'
numpy==2.0.0; python_version >= '3.9'
mypy
pytest
setuptools==69.0.3
wheel==0.42.0
onnx==1.16.1
argparse
sympy==1.12
flatbuffers
protobuf==4.21.12
packaging

=== debian/changelog ===
onnxruntime (1.19.2+dfsg-9) unstable; urgency=medium

  * Team upload.
  * Remove remaining dnnl-related config on riscv64 to fix build
  * d/rules: remove all potential loadable plugin files from
    python3-onnxruntime

 -- Shengqi Chen <harry@debian.org>  Fri, 24 Jan 2025 13:29:27 +0800

onnxruntime (1.19.2+dfsg-8) unstable; urgency=medium

  * Team upload.
  * d/tests: enable tests only on architectures with pytorch available
  * d/rules: disable onednn on riscv64 due to its lack of openmp support
  * d/rules: use ninja as cmake backend
  * d/patches: update metadata of some patches
  * lintian-overrides:
    + add no-manual-page for onnxruntime-tools
    + fix .so paths for libonnxruntime
  * d/control: mark onnxruntime-tools as Archtecture: all
  * d/control: remove disabled libnsync-dev from Build-Depends

 -- Shengqi Chen <harry@debian.org>  Thu, 23 Jan 2025 21:14:15 +0800

onnxruntime (1.19.2+dfsg-7) unstable; urgency=medium

  * Update symbols file for architectures where DNNL is enabled.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 21 Jan 2025 12:06:50 +0100

onnxruntime (1.19.2+dfsg-6) unstable; urgency=medium

  * Only install libonnxruntime_providers_dnnl.so on architectures
      where DNNL is enabled.

 -- Dylan Aïssi <daissi@debian.org>  Fri, 17 Jan 2025 15:40:13 +0100

onnxruntime (1.19.2+dfsg-5) unstable; urgency=medium

  * Autopkgtest: add providers.py to check the f32 GEMM performance
    for all supported providers. Currently on amd64 we have three providers:
    dnnl, xnnpack, and cpu (onnxruntime built-in).
  * Only B-D on XNNPACK for some architectures. Then it can be built on ppc64el.
  * Enable DNNL (i.e., oneDNN) execution provider for selected architectures.
  * Refresh symbols control file and update lintian overrides.
  * Override dh_python3 to remove redundant dnnl provider.

 -- Mo Zhou <lumin@debian.org>  Tue, 14 Jan 2025 19:05:30 -0500

onnxruntime (1.19.2+dfsg-4) unstable; urgency=medium

  [ Mo Zhou ]
  * Autopkgtest: test inference with a dummy neural net exported from PyTorch.

  [ Dylan Aïssi ]
  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Mon, 13 Jan 2025 14:55:09 +0100

onnxruntime (1.19.2+dfsg-3) experimental; urgency=medium

  [ Dylan Aïssi ]
  * Enable python binding (Closes: #1088901)
    - Build new binary package: python3-onnxruntime
    - Add new Build-Deps: dh-sequence-python3, dh-sequence-numpy3,
        python3-packaging, python3-protobuf, python3-pybind11.

  [ Mateus Rodrigues de Morais ]
  * Disable LTO and O3 optimization to fix FTBFS on Ubuntu

 -- Dylan Aïssi <daissi@debian.org>  Sat, 11 Jan 2025 11:31:55 +0100

onnxruntime (1.19.2+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Tue, 15 Oct 2024 19:28:48 +0200

onnxruntime (1.19.2+dfsg-1) experimental; urgency=medium

  [ Shengqi Chen ]
  * d/copyright: exclude more files with unclear license
  * New upstream version 1.19.2+dfsg (closes: #1080510, #1081664)
  * d/patches:
    + refresh & remove applied patches
    + add patch to use system absl (not yet enabled)
    + add patch to fix eigen3 compilation
    + add patch to fix xnnpack compilation
    + add patch to fix compilation with gcc-14
    + add patch to set SOVERSION of shared library
  * d/control: bump B-D version of libcpuinfo and libxnnpack
  * d/rules:
    + use ninja to build
    + enable hardening
    + do not re-generate fbs schema
  * d/: bump SONAME to libonnxruntime1.19.2

  [ Dylan Aïssi ]
  * Add patch adding aliases for library onnx
  * Add symbols file
  * Add upstream/metadata

 -- Dylan Aïssi <daissi@debian.org>  Thu, 10 Oct 2024 11:13:02 +0200

onnxruntime (1.16.3+dfsg-7) unstable; urgency=medium

  * Fix includedir in pkgconfig (Closes: #1079791)
  * Add a basic build autopkgtest for the library

 -- Dylan Aïssi <daissi@debian.org>  Tue, 27 Aug 2024 16:53:29 +0200

onnxruntime (1.16.3+dfsg-6) unstable; urgency=medium

  * Update patch to include the missing header in more files,
      fix FTBFS on arm64.

 -- Dylan Aïssi <daissi@debian.org>  Thu, 22 Aug 2024 09:54:30 +0200

onnxruntime (1.16.3+dfsg-5) unstable; urgency=medium

  * Add patch fixing compilation with newer flatbuffers (Closes: #1076959)
  * Add patch adding missing include <iomanip>

 -- Dylan Aïssi <daissi@debian.org>  Tue, 20 Aug 2024 17:45:03 +0200

=== debian/control ===
Source: onnxruntime
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Dylan Aïssi <daissi@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-python3,
               dh-sequence-numpy3,
               cmake,
               libboost-dev,
               libbenchmark-dev,
               libcpuinfo-dev (>= 0.0~git20240830.fa1c679),
               libeigen3-dev (>= 3.4.0),
               libflatbuffers-dev,
               libgmock-dev,
               libgtest-dev,
               libhowardhinnant-date-dev,
               libmsgsl-dev,
#               libnsync-dev,
               libonnx-dev,
               libonnx-testdata,
               libpng-dev,
               libprotobuf-dev,
               libpthreadpool-dev,
               libsafeint-dev,
               libre2-dev,
               libdnnl-dev [amd64 arm64 ppc64el s390x],
               libxnnpack-dev (>= 0.0~git20240821.87ee0b4) [amd64 arm64 armhf i386 riscv64 x32],
               ninja-build,
               nlohmann-json3-dev,
               protobuf-compiler,
               pkgconf,
               python3-all,
               python3-all-dev,
               python3-numpy,
               python3-onnx,
               python3-packaging,
               python3-protobuf,
               python3-pybind11,
               python3-setuptools,
               python3-wheel,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnxruntime
Vcs-Git: https://salsa.debian.org/deeplearning-team/onnxruntime.git
Homepage: https://github.com/microsoft/onnxruntime
Rules-Requires-Root: no

Package: libonnxruntime1.19.2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: cross-platform inference and training ML accelerator (shared lib)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the shared library.

Package: libonnxruntime-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libonnxruntime1.19.2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libonnxruntime1.13.1 (<< 1.16.3+dfsg-1~)
Replaces: libonnxruntime1.13.1 (<< 1.16.3+dfsg-1~)
Description: cross-platform inference and training ML accelerator (dev files)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the development files for libonnxruntime.

Package: onnxruntime-tools
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: cross-platform inference and training ML accelerator (tools)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the onnxruntime tools.

Package: python3-onnxruntime
Architecture: any
Section: python
Depends: libonnxruntime1.19.2 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: cross-platform inference and training ML accelerator (Python bindings)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the onnxruntime Python bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CFLAGS_MAINT_STRIP = -O3
export DEB_CXXFLAGS_MAINT_STRIP = -O3

# xnnpack is only available on several architectures.
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 riscv64 x32))
USE_XNNPACK=ON
else
USE_XNNPACK=OFF
endif

# dnnl is only available on several architectures.
# riscv64 is temporarily disabled until onednn has openmp support on it,
# because onnxruntime always sets DNNL_OPENMP when onnxruntime_USE_DNNL is set.
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 ppc64el s390x))
USE_DNNL=ON
else
USE_DNNL=OFF
endif

PYVERS=$(shell python3 -c 'import sysconfig;print (sysconfig.get_python_version())')

PATH_LIB=usr/lib/${DEB_HOST_MULTIARCH}
PATH_LIB_PYTHON=usr/lib/python3/dist-packages/onnxruntime/capi

%:
	dh $@ --buildsystem=cmake+ninja --sourcedirectory=cmake --builddirectory=.

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_INCLUDEDIR=include \
		-Deigen_SOURCE_PATH=/usr/include/eigen3 \
		-Donnxruntime_BUILD_BENCHMARKS=OFF \
		-Donnxruntime_BUILD_SHARED_LIB=ON \
		-Donnxruntime_BUILD_UNIT_TESTS=OFF \
		-Donnxruntime_DISABLE_ABSEIL=ON \
		-Donnxruntime_ENABLE_CPUINFO=ON \
		-Donnxruntime_ENABLE_PYTHON=ON \
		-Donnxruntime_ONNX_PROTO_DATA_DIR=/usr/lib/python3/dist-packages \
		-Donnxruntime_ONNX_TEST_DATA_DIR=/usr/share/libonnx-testdata/data \
		-Donnxruntime_USE_FULL_PROTOBUF=ON \
		-Donnxruntime_USE_PREINSTALLED_EIGEN=ON \
		-Donnxruntime_USE_XNNPACK=$(USE_XNNPACK) \
		-Donnxruntime_USE_DNNL=$(USE_DNNL) \
		-DPYTHON_VERSION=${PYVERS} \
		$(NULL)

override_dh_auto_build:
	dh_auto_build
	# Build Python bindings
	dh_auto_build --buildsystem=pybuild --sourcedirectory=.

override_dh_auto_install:
	dh_auto_install
	# Install Python bindings
	dh_auto_install --buildsystem=pybuild --sourcedirectory=.

execute_after_dh_link:
	# To avoid having large duplicated libraries
	dh_link -ppython3-onnxruntime \
	  ${PATH_LIB}/libonnxruntime.so.1.19.2 ${PATH_LIB_PYTHON}/libonnxruntime.so.1.19.2 \
	  ${PATH_LIB}/libonnxruntime_providers_shared.so.1.19.2 ${PATH_LIB_PYTHON}/libonnxruntime_providers_shared.so

override_dh_python3:
	dh_python3
	# remove loadable plugins already installed in libonnxruntime
	-find debian/python3-onnxruntime -type f -name 'libonnxruntime_providers_*.so*' -delete

override_dh_auto_test:
	# Do NOT run tests, they depend on *.onnx dataset with unclear license
	# See https://github.com/microsoft/onnxruntime/issues/8963

override_dh_auto_clean:

=== debian/tests/control ===
Tests: build
Depends: build-essential, pkgconf, libonnxruntime-dev
Restrictions: superficial

Test-Command: python3 debian/tests/inference.py
Depends: @, python3-torch, python3-numpy, python3-onnx,
Restrictions: allow-stderr
Architecture: amd64 arm64 ppc64el s390x riscv64

Test-Command: python3 debian/tests/providers.py
Depends: @, python3-torch, python3-numpy, python3-onnx,
Restrictions: allow-stderr
Architecture: amd64 arm64 ppc64el s390x riscv64

# this needs python3-onnxscript, which is net yet packaged.
#Test-Command: python3 transformer.py
#Depends: @, python3-torch, python3-numpy,
#Restrictions: allow-stderr
#Architecture: amd64 arm64 ppc64el s390x riscv64

## onnxruntime 1.20.1+dfsg

=== debian/changelog ===
onnxruntime (1.20.1+dfsg-2) unstable; urgency=medium

  * d/rules: disable xnnpack EP on riscv64 (currently unusable)
  * d/patches: add patch to set noexecstack in linker flags
    (closes: #1098205)

 -- Shengqi Chen <harry@debian.org>  Wed, 19 Feb 2025 14:27:32 +0800

onnxruntime (1.20.1+dfsg-1) unstable; urgency=medium

  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Tue, 18 Feb 2025 22:05:43 +0800

onnxruntime (1.20.1+dfsg-1~exp3) experimental; urgency=medium

  [ Mo Zhou ]
  * Patch cmake to avoid -lkleidiai to fix arm64 FTBFS.

  [ Shengqi Chen ]
  * d/patches:
    + refresh & rename arm64-no-kleidiai to use-system-xnnpack
    + update use-system-xnnpack.patch to disable all downloading
  * d/salsa-ci.yml: enable arm64 build test
  * d/control: add myself in uploaders

 -- Shengqi Chen <harry@debian.org>  Tue, 18 Feb 2025 02:04:15 +0800

onnxruntime (1.20.1+dfsg-1~exp2) experimental; urgency=medium

  * Don't make providers versioned
  * Add some Conflicts, Replaces and Breaks to avoid
      conflicts with providers (Closes: #1094599)
  * Add more lintian overrides for providers plugins

 -- Dylan Aïssi <daissi@debian.org>  Thu, 30 Jan 2025 11:00:21 +0100

onnxruntime (1.20.1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.20.1+dfsg
    + bump SONAME to libonnxruntime1.20.1
  * d/patches:
    + refresh existing patches, remove merged patches
    + add more hunks to fix build issue with eigen3
    + add hunk to fix c++ build issue
  * d/control: specify correct version of libxnnpack-dev in B-D

 -- Shengqi Chen <harry@debian.org>  Tue, 28 Jan 2025 19:21:58 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: onnxruntime
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>,
-           Dylan Aïssi <daissi@debian.org>
+           Dylan Aïssi <daissi@debian.org>,
+           Shengqi Chen <harry@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -27,7 +28,7 @@
                libsafeint-dev,
                libre2-dev,
                libdnnl-dev [amd64 arm64 ppc64el s390x],
-               libxnnpack-dev (>= 0.0~git20240821.87ee0b4) [amd64 arm64 armhf i386 riscv64 x32],
+               libxnnpack-dev (>= 0.0~git20241108.4ea82e5~) [amd64 arm64 armhf i386 riscv64 x32],
                ninja-build,
                nlohmann-json3-dev,
                protobuf-compiler,
@@ -48,12 +49,16 @@
 Homepage: https://github.com/microsoft/onnxruntime
 Rules-Requires-Root: no
 
-Package: libonnxruntime1.19.2
+Package: libonnxruntime1.20.1
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Conflicts: libonnxruntime1.19.2
+Replaces: libonnxruntime1.19.2,
+          libonnxruntime-dev (<< 1.20.1+dfsg-1~exp2~)
+Breaks: libonnxruntime-dev (<< 1.20.1+dfsg-1~exp2~)
 Description: cross-platform inference and training ML accelerator (shared lib)
  ONNX Runtime is a performance-focused complete scoring engine for Open Neural
  Network Exchange (ONNX) models, with an open extensible architecture to
@@ -69,7 +74,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libonnxruntime1.19.2 (= ${binary:Version}),
+Depends: libonnxruntime1.20.1 (= ${binary:Version}),
          ${misc:Depends}
 Breaks: libonnxruntime1.13.1 (<< 1.16.3+dfsg-1~)
 Replaces: libonnxruntime1.13.1 (<< 1.16.3+dfsg-1~)
@@ -104,7 +109,7 @@
 Package: python3-onnxruntime
 Architecture: any
 Section: python
-Depends: libonnxruntime1.19.2 (= ${binary:Version}),
+Depends: libonnxruntime1.20.1 (= ${binary:Version}),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,11 @@
 export DEB_CFLAGS_MAINT_STRIP = -O3
 export DEB_CXXFLAGS_MAINT_STRIP = -O3
 
+SOVERSION=1.20.1
+
 # xnnpack is only available on several architectures.
-ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 riscv64 x32))
+# on riscv64 the provider is not usable: https://ci.debian.net/packages/o/onnxruntime/testing/riscv64/57967709/
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 x32))
 USE_XNNPACK=ON
 else
 USE_XNNPACK=OFF
@@ -61,8 +64,7 @@
 execute_after_dh_link:
 	# To avoid having large duplicated libraries
 	dh_link -ppython3-onnxruntime \
-	  ${PATH_LIB}/libonnxruntime.so.1.19.2 ${PATH_LIB_PYTHON}/libonnxruntime.so.1.19.2 \
-	  ${PATH_LIB}/libonnxruntime_providers_shared.so.1.19.2 ${PATH_LIB_PYTHON}/libonnxruntime_providers_shared.so
+	  ${PATH_LIB}/libonnxruntime.so.$(SOVERSION) ${PATH_LIB_PYTHON}/libonnxruntime.so.$(SOVERSION)
 
 override_dh_python3:
 	dh_python3
@@ -75,3 +77,7 @@
 
 override_dh_auto_clean:
 
+override_dh_makeshlibs:
+	dh_makeshlibs \
+		--exclude=/usr/lib/$(DEB_HOST_MULTIARCH)/libonnxruntime_providers_ \
+		-- -c4

## onnxruntime 1.21.0%2Bdfsg

=== onnxruntime/python/tools/transformers/requirements.txt ===
onnx >= 1.8
numpy >= 1.19.0
coloredlogs
psutil
py-cpuinfo
py3nvml
packaging
transformers >= 4.18.0
scipy
sentencepiece
pillow

# please follow https://pytorch.org/ to install PyTorch for your OS
torch >= 1.13.1

=== onnxruntime/python/tools/transformers/models/stable_diffusion/requirements/cuda12/requirements.txt ===
-r ../requirements.txt

onnxruntime-gpu>=1.19.2

py3nvml

# The version of cuda-python shall be compatible with installed CUDA version.
# For demo of TensorRT excution provider and TensortRT.
cuda-python>=12.1.0

# For windows, cuda-python need the following
pywin32; platform_system == "Windows"

# For windows, run `conda install -c conda-forge nvtx` instead
nvtx; platform_system != "Windows"

# Please install PyTorch 2.4 or above using one of the following commands:
# pip3 install torch --index-url https://download.pytorch.org/whl/cu124

# Run the following command to install some extra packages for onnx graph optimization for TensorRT manually.
# pip3 install --upgrade polygraphy onnx-graphsurgeon --extra-index-url https://pypi.ngc.nvidia.com

=== tools/ci_build/github/linux/docker/inference/aarch64/python/cpu/scripts/requirements.txt ===
numpy==1.21.6 ; python_version < '3.9'
numpy==2.1.2 ; python_version >= '3.9'
mypy
pytest
setuptools>=68.2.2
wheel
onnx==1.17.0 ; python_version < '3.13'
protobuf==4.21.12
sympy==1.12
flatbuffers
